import buffer

class SelBuffer(buffer.Buffer):
	classname = 'selection'

	def __init__(self, bufname, initbody=None, prompt='Select an option:\n'):
		buffer.Buffer.__init__(self, bufname)
		if (initbody == None):
			initbody = []
		self.body = initbody
		self.prompt = prompt

	def getviewclass(self):
		return selwindow.SelWindow

	def replace(self, arr):
		self.changed()
		self.body = list(arr)
		self.watch.signal(watcher.SIG_DATA)

	def changeprompt(self, prompt='Select an option:\n'):
		self.changed()
		self.prompt = prompt
		self.watch.signal(watcher.SIG_DATA)

	def serialize(self, fl):
		for st in self.body:
			fl.write(st+'\n')

buffer.registerclass(SelBuffer)

def getbyname(nam):
	return buffer.getbyname(nam, SelBuffer)

import watcher
import selwindow
